Earlier in 16a4c61, we taught "read-tree -m -u" not to be
confused when switching from a branch that has a path frotz/filfre
to another branch that has a symlink frotz that points at xyzzy/
directory. The fix was incomplete in that it was still confused
when coming back (i.e. switching from a branch with frotz -> xyzzy/
to another branch with frotz/filfre).
This fix is rather expensive in that for a path that is created
we would need to see if any of the leading component of that
path exists as a symbolic link in the filesystem (in which case,
we know that path itself does not exist, and the fact we already
decided to check it out tells us that in the index we already
know that symbolic link is going away as there is no D/F
conflict).
Signed-off-by: Junio C Hamano <gitster@pobox.com>
---
Re: [BUG (or misfeature?)] git checkout and symlinks
Pierre Habouzit <madcoder@debian.org> writes:
> if in a branch [branch1] you track the file: dir1/file1.c
> and in the branch [branch2] you track elsewhere/file1.c and dir1 be
> symlink on elsewhere, then it's not possible to checkout the branch
> [branch1] if your previous checkout was [branch2]. You have to manually
> remove the symlink `dir1` else git complains that checkouting branch1
> would overwrite dir1/file1.c.
>
> I'm not sure how to fix this, and it's quite painful actually :)
We probably could add a path buffer to cache the last look-up
made by has_symlink_leading_path(), like the other caller
does, but this is to give the fix a wider exposure and testing
early.
t/t2007-checkout-symlink.sh | 50 +++++++++++++++++++++++++++++++++++++++++++
unpack-trees.c | 3 ++
2 files changed, 53 insertions(+), 0 deletions(-)
create mode 100755 t/t2007-checkout-symlink.sh
diff --git a/t/t2007-checkout-symlink.sh b/t/t2007-checkout-symlink.sh
new file mode 100755
index 0000000..0526fce
--- /dev/null
+++ b/t/t2007-checkout-symlink.sh
@@ -0,0 +1,50 @@
+#!/bin/sh
+#
+# Copyright (c) 2007 Junio C Hamano
+
+test_description='git checkout to switch between branches with symlink<->dir'
+
+. ./test-lib.sh
+
+test_expect_success setup '
+
+ mkdir frotz &&
+ echo hello >frotz/filfre &&
+ git add frotz/filfre &&
+ test_tick &&
+ git commit -m "master has file frotz/filfre" &&
+
+ git branch side &&
+
+ echo goodbye >nitfol &&
+ git add nitfol
+ test_tick &&
+ git commit -m "master adds file nitfol" &&
+
+ git checkout side &&
+
+ git rm --cached frotz/filfre &&
+ mv frotz xyzzy &&
+ ln -s xyzzy frotz &&
+ git add xyzzy/filfre frotz &&
+ test_tick &&
+ git commit -m "side moves frotz/ to xyzzy/ and adds frotz->xyzzy/"
+
+'
+
+test_expect_success 'switch from symlink to dir' '
+
+ git checkout master
+
+'
+
+rm -fr frotz xyzzy nitfol &&
+git checkout -f master || exit
+
+test_expect_success 'switch from dir to symlink' '
+
+ git checkout side
+
+'
+
+test_done
diff --git a/unpack-trees.c b/unpack-trees.c
index cac2411..89dd279 100644
--- a/unpack-trees.c
+++ b/unpack-trees.c
@@ -495,6 +495,9 @@ static void verify_absent(const char *path, const char *action,
if (o->index_only || o->reset || !o->update)
return;
+ if (has_symlink_leading_path(path, NULL))
+ return;
+
if (!lstat(path, &st)) {
int cnt;
-
To unsubscribe from this list: send the line "unsubscribe git" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at http://vger.kernel.org/majordomo-info.html
| Robin Lee Powell | NFS hang + umount -f: better behaviour requested. |
| Linus Torvalds | Re: Dual-Licensing Linux Kernel with GPL V2 and GPL V3 |
| S.Çağlar | Rescheduling interrupts |
| J.A. | Linux 2.6.27-git3: rtl8169 oops and wireless missing symbols |
git: | |
| A Large Angry SCM | Notes on Using Git with Subprojects |
| Michael S. Tsirkin | git-kill: rewrite history removing a commit |
| Aubrey Li | git proxy issue |
| Luke Diamand | perforce import: git-p4 memory usage |
| mufurcz | Nvidia Quadro NVS 140M |
| Juan Miscaro | When will OpenBSD support UTF8? |
| Jeff Ross | U320 Drive on U160 controller? |
| GVG GVG | ssh_exchange_identification: Connection closed by remote host |
| Jeff Garzik | Re: [PATCH] Add eeprom_bad_csum_allow module option to e1000. |
| Martin Willi | [RFC PATCH] xfrm: Accept XFRM_STATE_AF_UNSPEC SAs on IPv4/IPv6 only hosts |
| PJ Waskiewicz | [PATCH 3/3] ixgbe: Enable Data Center Bridging (DCB) support |
| David Miller | Re: [RFC,PATCH] loopback: calls netif_receive_skb() instead of netif_rx() |
